<?php
/**
* Controller.class.php
*
*
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
* @version              $Id: Controller.class.php,v 1.3 2007-02-18 13:40:01 jankul Exp $
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// FotoContest.class.php
// Copyright (C) 2007 Jan Kulmann <jankul@tzi.de>
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+


require_once $GLOBALS['ABSOLUTE_PATH_STUDIP'].("functions.php");

require_once("Album.class.php");
require_once("Photo.class.php");
require_once("Comment.class.php");

class Controller {

	var $max_quota_size;

	function Controller() {
		$this->max_quota_size = get_config('PHOTO_UPLOAD_QUOTA');
	}

	function get_all_albums($user_id) {
		$ret = array();
		$db = new DB_Seminar();
		$db->queryf("SELECT album_id FROM mp_album WHERE user_id='%s'",$user_id);
		while ($db->next_record()) {
			$a = new Album();
			$a->load($db->f("album_id"));
			array_push($ret, $a);
		}
		return $ret;
	}

	function get_public_viewable_album_count($user_id) {
		$db = new DB_Seminar();
		$db->queryf("SELECT album_id FROM mp_album WHERE user_id='%s' AND public=1",$user_id);
		return $db->num_rows();
	}

	function get_all_photos_in_album($user_id,$album_id) {
		$ret = array();
		$db = new DB_Seminar();
		$db->queryf("SELECT photo_id FROM mp_photo WHERE user_id='%s' AND album_id='%s' ORDER BY sort",$user_id,$album_id);
		while ($db->next_record()) {
			$p = new Photo();
			$p->load($db->f("photo_id"));
			array_push($ret, $p);
		}
		return $ret;
	}

	function get_number_of_all_photo_comments($photo_id) {
		$db = new DB_Seminar();
		$db->queryf("SELECT comment_id FROM mp_photo_comment WHERE photo_id='%s' ORDER BY mkdate DESC",$photo_id);
		return $db->num_rows();
	}

	function get_all_photo_comments($photo_id) {
		$ret = array();
		$db = new DB_Seminar();
		$db->queryf("SELECT comment_id FROM mp_photo_comment WHERE photo_id='%s' ORDER BY mkdate DESC",$photo_id);
		while ($db->next_record()) {
			$c = new Comment();
			$c->load($db->f("comment_id"));
			array_push($ret, $c);
		}
		return $ret;
	}

		// Wandelt Diskgroessen in lesbarere Schreibweisen um
	function translate_disksize($size) {
	        if ($size) {
	                $ret = "0 KB";
	                if ($size < 1024000) $ret = (round(($size / 1000),3)) . " KB"; // KB
	                if ($size > 1024000) $ret = (round(($size / 1000 / 1000),3)) . " MB"; // MB
	                if ($size > 1024000000) $ret = (round(($size / 1000 / 1000 / 1000),3)) . " GB"; // GB
	                return $ret;
	        }
	        return "0 KB";
	}
	
	function get_absolut_content_size_in_db($user_id) {
		if ($user_id != "") {
			$db = new DB_Seminar();
			$db->queryf("SELECT SUM(LENGTH(c.file_content_thumb)+LENGTH(c.file_content)) quota FROM mp_file_content c, mp_photo p WHERE p.user_id='%s' AND c.file_id=p.file_id",$user_id);
			if ($db->next_record())
				return $db->f("quota");
		}
		return 0;
	}

	function new_file_upload($link, $album_id) {
	        /*?>
		<script type="text/javascript" language="javascript">
	        function show_w(x){
	                msg_window=window.open("","messagewindow","height=250,width=200,left=20,top=20,scrollbars=no,resizable=no,toolbar=no");
	                msg_window.document.write("<html><head><title>Datei Upload</title></head>");
	                msg_window.document.write("<body bgcolor='#ffffff'><center><p><img src='<? echo $GLOBALS['ASSETS_URL']?>images/alienupload.gif' width='165' height='125'></p>");
	                msg_window.document.write("<p><font face='arial, helvetica, sans-serif'>Die Datei&nbsp;<?=_("wird hochgeladen.")?><br>&nbsp;<?=_("Bitte haben sie etwas Geduld!")?><br /></font></p></body></html>");
	        }
	        <?
	        echo "  function checkInput(){\n";
	        //echo "    if (document.add_new_foto.titel.value!=\"\" && document.add_new_foto.imgfile.value!=\"\"){\n";
	        echo "      show_w('x');";
	        echo "      return true;\n";
	        //echo "    }\n";
	        echo "  }\n";
	        echo "</SCRIPT>\n";*/
	
	        //echo "\n<body onUnLoad=\"msg_window.close();\">";
	
		echo "<CENTER>\n";
		echo "<DIV STYLE=\"color:red; width:600px; margin:5px; padding:5px;\">"._("Mit dem Upload erkl&auml;re ich, dass die hochgeladenen Dateien keine fremden Urheberrechte verletzen und nicht gegen die Nutzungsordnung verstoen!")."</DIV>\n";
		echo "<DIV STYLE=\"width:600px; margin:25px; padding:5px; border-color:red; border-width:thin; border-style:solid\">\n";
	        echo "<TABLE BORDER=\"0\" WIDTH=\"100%\" CELLSPACING=\"0\" CELLPADDING=\"1\">\n";
	        //echo "<FORM ENCTYPE=\"multipart/form-data\" NAME=\"add_new_foto\" METHOD=\"POST\" onSubmit=\"return checkInput();\" ACTION=\"$link\">\n";
	        echo "<FORM ENCTYPE=\"multipart/form-data\" NAME=\"add_new_foto\" METHOD=\"POST\" ACTION=\"$link\">\n";
	        echo "  <INPUT TYPE=\"hidden\" NAME=\"modus\" VALUE=\"foto_upload\">\n";
	        echo "  <INPUT TYPE=\"hidden\" NAME=\"album_id\" VALUE=\"$album_id\">\n";
	        echo "  <TR>\n";
	        echo "    <TD><FONT SIZE=\"-1\"><B>&nbsp;Dateiname:</B></FONT></TD><TD COLSPAN=\"5\"><INPUT TYPE=\"file\" NAME=\"imgfile\" SIZE=\"45\" style=\"width:400px\"></TD>\n";
	        echo "  </TR>\n";
	        echo "  <TR>\n";
	        echo "    <TD><FONT SIZE=\"-1\"><B>&nbsp;Titel:</B></FONT></TD><TD COLSPAN=\"5\"><INPUT TYPE=\"text\" NAME=\"titel\" VALUE=\"\" MAXLENGTH=\"255\" style=\"width:400px\"></TD>\n";
	        echo "  </TR>\n";
	        echo "  <TR>\n";
	        echo "    <TD VALIGN=\"TOP\"><FONT SIZE=\"-1\"><B>&nbsp;Beschreibung:</B></FONT></TD><TD COLSPAN=\"5\"><TEXTAREA NAME=\"beschreibung\" style=\"width:400px; height:100px\"></TEXTAREA></TD>\n";
	        echo "  </TR>\n";
	        echo "  <TR>";
	        echo "    <TD COLSPAN=\"8\" ALIGN=\"center\" VALIGN=\"TOP\">";
	        echo "<INPUT TYPE=\"IMAGE\" ".makeButton("absenden","src")." border=0 value=\"" . _("absenden") . "\">&nbsp;&nbsp;";
	        echo "<INPUT TYPE=\"IMAGE\" ".makeButton("abbrechen","src")." border=0 value=\"" . _("abbrechen") . "\" onClick=\"document.location.href='$link';\"></TD>\n";
	        echo "  </TR>\n";
	        echo "  <TR>\n";
	        echo "    <TD COLSPAN=\"8\" ALIGN=\"center\" VALIGN=\"TOP\">";
	        echo "      <FONT SIZE=\"-1\">Die Bilddatei darf max. <B>5 MB</B> gro sein, es sind nur Dateien mit der Endung <B>.jpg und .gif</B> erlaubt!<BR></FONT>";
	 	echo "    </TD>\n";
	        echo "  </TR>\n";
	        echo "  <TR>\n";
	        echo "    <TD COLSPAN=\"8\" ALIGN=\"center\" VALIGN=\"TOP\">&nbsp;</TD>";
	        echo "  </TR>\n";
	        echo "</FORM>\n";
		echo "</TABLE>\n";
		echo "</DIV>\n";
	
	        // ZIP-Uploadform
		echo "<DIV STYLE=\"width:600px; margin:25px; padding:5px; border-color:red; border-width:thin; border-style:solid\">\n";
	        echo "<TABLE BORDER=\"0\" WIDTH=\"100%\" CELLSPACING=\"0\" CELLPADDING=\"1\">\n";
	        echo "<FORM ENCTYPE=\"multipart/form-data\" NAME=\"add_new_zip\" METHOD=\"POST\" onSubmit='if(document.add_new_zip.zipfile.value==\"\")return false;w();return true;' ACTION=\"$link\">\n";
	        echo "  <INPUT TYPE=\"hidden\" NAME=\"modus\" VALUE=\"zip_upload\">\n";
	        echo "  <INPUT TYPE=\"hidden\" NAME=\"album_id\" VALUE=\"$album_id\">\n";
	        echo "  <TR>\n";
	        echo "    <TD><FONT SIZE=\"-1\"><B>&nbsp;ZIP-Dateiname:</B></FONT></TD><TD COLSPAN=\"5\"><INPUT TYPE=\"file\" NAME=\"zipfile\" SIZE=\"45\" style=\"width:400px\"></TD>\n";
	        echo "  </TR>\n";
	        echo "  <TR>";
	        echo "    <TD COLSPAN=\"8\" ALIGN=\"center\" VALIGN=\"TOP\">";
	        echo "<INPUT TYPE=\"IMAGE\" ".makeButton("absenden","src")." border=0 value=\"" . _("absenden") . "\">&nbsp;&nbsp;";
	        echo "<INPUT TYPE=\"IMAGE\" ".makeButton("abbrechen","src")." border=0 value=\"" . _("abbrechen") . "\" onClick=\"document.location.href='$link';\"></TD>\n";
	        echo "  </TR>\n";
	        echo "</FORM>\n";
	        echo "  <TR>\n";
	        echo "    <TD COLSPAN=\"8\" ALIGN=\"center\" VALIGN=\"TOP\">";
	        echo "      <FONT SIZE=\"-1\">Die ZIP-Datei darf max. <B>40 MB</B> gro sein, darin sind nur Dateien mit der Endung <B>.jpg und .gif</B> erlaubt!</FONT>";
	        echo "    </TD>\n";
	        echo "  </TR>\n";
	        echo "</TABLE>\n";
	        echo "</DIV></CENTER>\n";
	}

	function add_new_foto($imgfile, $imgfile_size, $imgfile_name, $album_id, $titel, $beschreibung) {
		if ($imgfile_size==0) return "errorFehler beim hochladen des Fotos! Dateigr&ouml;sse 0 Byte!";

		if ($this->get_absolut_content_size_in_db($GLOBALS['auth']->auth['uid']) > $this->max_quota_size)
			return "errorSpeicherplatz ersch&ouml;pft!";

		//Dateiendung bestimmen
	        $ext = NULL;
        	$dot = strrpos($imgfile_name,".");
	        if ($dot) {
        	        $l = strlen($imgfile_name) - $dot;
                	$ext = strtolower(substr($imgfile_name,$dot+1,$l));
	        }
		$db = new DB_Seminar();
		$db->queryf("SELECT MAX(sort) maxsort FROM mp_photo WHERE album_id='%s'",$album_id);
		$db->next_record();
		$max_sort = ($db->f("maxsort") ? $db->f("maxsort") : 1);
		$file_id = md5(uniqid(time()));
		$p = new Photo();
		$p->set_file_id($file_id);
		$msg = $this->imaging($p, $file_id, $imgfile, $imgfile_size, $imgfile_name);
                $pos = strpos($msg, "error");
		if ($pos===false) {
			$p->set_user_id($GLOBALS['auth']->auth['uid']);
			$p->set_album_id($album_id);
			$p->set_mkdate(time());
			$p->set_titel($titel);
			$p->set_beschreibung($beschreibung);
			$p->set_ext($ext);
			$p->set_sort($max_sort + 1);
			$p->save();
		} else
			$msg = "errorFehler beim hochladen des Fotos!";
		return $msg;
	}

	function imaging(&$photo_obj, $foto_id, $img, $img_size, $img_name) {
	        global $TMP_PATH, $CONVERT_PATH, $auth, $UPLOAD_PATH;
	
	        $max_file_size = 8000; //max Gre der Bilddatei in KB
	        $img_max_h_thumb = 160; // max picture height (thumbnail)
	        $img_max_h = 800; // max picture height
	        $img_max_w_thumb = 160; // max picture width (thumbnail)
	        $img_max_w = 800; // max picture width
	        //$uploaddir = $UPLOAD_PATH."/fotocontest"; //Uploadverzeichnis fr Bilder
	        $uploaddir = $TMP_PATH; //Uploadverzeichnis fr Bilder
	
	        $msg = "";
	        if ($img_size > ($max_file_size*1024)) { //Bilddatei ist zu gro
	                $msg = "errorError 1: " . sprintf(_("Die hochgeladene Bilddatei ist %s KB gro.<br>Die maximale Dateigre betrgt %s KB!"), round($img_size/1024), $max_file_size);
	                return $msg;
	        }
	
	        if (!$img_name) { //keine Datei ausgewhlt!
	                $msg = "errorError 2: " . _("Sie haben keine Datei zum Hochladen ausgewhlt!");
	                return $msg;
	        }
	
	        //Dateiendung bestimmen
	        $dot = strrpos($img_name,".");
	        if ($dot) {
	                $l = strlen($img_name) - $dot;
	                $ext = strtolower(substr($img_name,$dot+1,$l));
	        }
	        //passende Endung ?
	        if ($ext != "jpg" && $ext != "gif" ) {
	                $msg = "error" . sprintf(_("Der Dateityp der Bilddatei ist falsch (%s).<br>Es sind nur die Dateiendungen .gif und .jpg erlaubt!"), $ext);
	                return $msg;
	        }
	
	        //na dann kopieren wir mal...
	        $newfile = $uploaddir . "/foto_".$foto_id.".".$ext;
	        $newfile_thumb = $uploaddir . "/foto_thumb_".$foto_id.".".$ext;
	        if(!@copy($img,$newfile) || !@copy($img,$newfile_thumb)) {
	                @unlink($newfile);
	                @unlink($newfile_thumb);
	                $msg = "errorError 4: " . _("Es ist ein Fehler beim Kopieren der Datei $img aufgetreten. Das Bild wurde nicht hochgeladen!");
	                return $msg;
	        } else {
	                list($width, $height, $img_type, ) = @getimagesize($img);
	                // Check picture size
	                $hscale = $height / $img_max_h;
	                $wscale = $width / $img_max_w;
	                $hscale_thumb = $height / $img_max_h_thumb;
	                $wscale_thumb = $width / $img_max_w_thumb;
	                // Thumbnails
			if (($hscale_thumb > 1) || ($wscale_thumb > 1)) {
	                        $scale = ($hscale_thumb > $wscale_thumb)? $hscale_thumb : $wscale_thumb;
	                        $newwidth = floor($width / $scale);
	                        $newheight= floor($height / $scale);
	                        $ret_val = false;
	                        if (file_exists($CONVERT_PATH)){
	                                system($CONVERT_PATH . ' -resize ' . $newwidth . 'x' . $newheight . '! ' . $newfile_thumb .' ' . $newfile_thumb, $ret_val);
	                        } else if (extension_loaded('gd') && function_exists('imagecopyresampled')){
	                                // leeres Bild erzeugen
	                                $img_res = ImageCreateTrueColor($newwidth, $newheight);
	                                switch ($img_type) {  //original Bild einlesen
	                                case 1: //GIF
	                                        $img_org = ImageCreateFromGIF($img);
	                                        break;
	                                case 2: //JPG
	                                        $img_org = ImageCreateFromJPEG($img);
	                                        break;
	                                case 3: //PNG
	                                        $img_org = ImageCreateFromPNG($img);
	                                        break;
	                                default:
	                                        $img_org = FALSE;
	                                } // end switch
	                                if (!$img_org) {
	                                        $msg = "errorError 5: " . _("Es ist ein Fehler beim Kopieren der Datei aufgetreten. Das Bild wurde nicht hochgeladen!");
	                                        @unlink($newfile);
	                                        @unlink($newfile_thumb);
	                                        return $msg;
	                                }
	                                // resampeln und als jpg speichern
	                                $ret_val = ImageCopyResampled ( $img_res, $img_org, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);
	                                $ret_val = ImageJPEG ( $img_res, $newfile_thumb , 70);
	                                $ret_val = $ret_val ? false : true;
	                                ImageDestroy ( $img_res);
	                                ImageDestroy ( $img_org);
	                        } else {
	                                $ret_val = true; //Fehler!!!
	                        }
	                        if ($ret_val){
	                                @unlink($newfile);
	                                @unlink($newfile_thumb);
	                                $msg = "errorError 6:" . _("Es ist ein Fehler beim Kopieren der Datei aufgetreten. Das Bild wurde nicht hochgeladen!");
	                                return $msg;
	                        }
	                }
	                // Big-Images
	                if (($hscale > 1) || ($wscale > 1)) {
	                        $scale = ($hscale > $wscale)? $hscale : $wscale;
	                        $newwidth = floor($width / $scale);
	                        $newheight= floor($height / $scale);
	                        $ret_val = false;
	                        if (file_exists($CONVERT_PATH)){
	                                system($CONVERT_PATH . ' -resize ' . $newwidth . 'x' . $newheight . '! ' . $newfile .' ' . $newfile, $ret_val);
	                        } else if (extension_loaded('gd') && function_exists('imagecopyresampled')){
	                                // leeres Bild erzeugen
	                                $img_res = ImageCreateTrueColor($newwidth, $newheight);
	                                switch ($img_type) {  //original Bild einlesen
	                                case 1: //GIF
						$img_org = ImageCreateFromGIF($img);
	                                        break;
	                                case 2: //JPG
	                                        $img_org = ImageCreateFromJPEG($img);
	                                        break;
	                                case 3: //PNG
	                                        $img_org = ImageCreateFromPNG($img);
	                                        break;
	                                default:
	                                        $img_org = FALSE;
	                                } // end switch
	                                if (!$img_org) {
	                                        $msg = "errorError 7: " . _("Es ist ein Fehler beim Kopieren der Datei aufgetreten. Das Bild wurde nicht hochgeladen!");
	                                        @unlink($newfile);
	                                        @unlink($newfile_thumb);
	                                        return $msg;
	                                }
	                                // resampeln und als jpg speichern
	                                $ret_val = ImageCopyResampled ( $img_res, $img_org, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);
	                                $ret_val = ImageJPEG ( $img_res, $newfile , 70);
	                                $ret_val = $ret_val ? false : true;
	                                ImageDestroy ( $img_res);
	                                ImageDestroy ( $img_org);
	                        } else {
	                                $ret_val = true; //Fehler!!!
	                        }
	                        if ($ret_val){
	                                @unlink($newfile);
	                                @unlink($newfile_thumb);
	                                $msg = "errorError 8: " . _("Es ist ein Fehler beim Kopieren der Datei aufgetreten. Das Bild wurde nicht hochgeladen!");
	                                return $msg;
	                        }
	                }
			$photo_obj->set_file_content(base64_encode(file_get_contents($newfile)), base64_encode(file_get_contents($newfile_thumb)));
			@unlink($newfile);
			@unlink($newfile_thumb);
	                $msg = "msg" . _("Die Bilddatei \"$img_name\" wurde erfolgreich hochgeladen")."";
	                return $msg;
	        }
	        return FALSE;
	}

	// Liest ein Verzeichnis ein
	function GetDirContents($dir){
		ini_set("max_execution_time",100);
		if (!is_dir($dir)) return "errorFehler! kein g&uuml;ltiges Verzeichnis: $dir!";
		if ($root=@opendir($dir)){
			while ($file=readdir($root)){
				if($file=="." || $file==".."){continue;}
				if(is_dir($dir."/".$file)){
					$files=array_merge($files,GetDirContents($dir."/".$file));
				}else{
					$files[]=$dir."/".$file;
				}
			}
		}
		return $files;
	}

	function add_new_zip($zipfile, $zipfile_size, $zipfile_name, $album_id) {
	        global $TMP_PATH;

		$db = new DB_Seminar();
	
	        $zipdir = $TMP_PATH."/".$contest_id."_".time();
	        $zipname = basename($zipfile).".zip";

		if ($zipfile_size > 50000 * 1024)
			return "errorDie hochgeladene ZIP-Datei ist zu gross!";
	
	        if (!@copy($zipfile, $TMP_PATH."/$zipname")) return "errorFehler beim Kopieren des ZIP-Archivs!";;
	
	        // ZIP-Testing...
	        exec("unzip -t $TMP_PATH/$zipname 2>&1", $out, $err);
	        if ($err) return "errorFehler im ZIP-Archiv!";
	
	        unset($out);
	        unset($err);
	
	        // ZIP-Auspacking...
	        exec("unzip -jno $TMP_PATH/$zipname -d $zipdir 2>&1", $out, $err);
	        if ($err) return "errorFehler beim Entpacken des ZIP-Archivs!";
	
	        $files = $this->GetDirContents($zipdir);
	
	        if (!is_array($files)) return $files;
	
	        $good = 0;
	        $not_good = 0;
	
	        if (is_array($files))
	        foreach ($files as $key=>$val) {
			if ($this->get_absolut_content_size_in_db($GLOBALS['auth']->auth['uid']) > $this->max_quota_size)
	                        return "errorSpeicherplatz ersch&ouml;pft!";
	                //Dateiendung bestimmen
	                $ext = NULL;
	                $dot = strrpos($val,".");
	                if ($dot) {
	                        $l = strlen($val) - $dot;
	                        $ext = strtolower(substr($val,$dot+1,$l));
	                }
	
	                if (filesize($val)==0) {
	                        $not_good++;
	                        $msg .= "errorFehler beim hochladen des Fotos: ".basename($val).". Dateigr&ouml;sse 0 Byte!";
	                        unlink($val);
	                        continue;
	                }

			$db->queryf("SELECT MAX(sort) maxsort FROM mp_photo WHERE album_id='%s'",$album_id);
			$db->next_record();
			$max_sort = ($db->f("maxsort") ? $db->f("maxsort") : 1);

			$file_id = md5(uniqid(time()));
        	        $p = new Photo();
       	                $p->set_file_id($file_id);
	                $msg2 = $this->imaging($p, $file_id, $val, filesize($val), basename($val));
        	        $pos = strpos($msg2, "error");
	                if ($pos===false) {
	                        $p->set_user_id($GLOBALS['auth']->auth['uid']);
        	                $p->set_album_id($album_id);
                	        $p->set_mkdate(time());
                        	$p->set_titel("");
	                        $p->set_beschreibung("");
				$p->set_ext($ext);
				$p->set_sort($max_sort + 1);
                	        $p->save();
				$good++;
	                } else {
				$not_good++;
				$msg .= $msg2;
			}
	                unlink($val);
	        }
	        $msg .= "msg$good Bild(er) hochgeladen / $not_good Problem(e)";
	        rmdir($zipdir);
	        unlink($TMP_PATH."/$zipname");
	        return $msg;
	}

	function image_download_fullsize(&$photo) {
		echo base64_decode($photo->get_file_content());
	}

	function image_download_thumb(&$photo) {
		echo base64_decode($photo->get_file_content_thumb());
	}
	
}

?>
