<?php
/**
* MyPhotoPlugin.class.php
* 
* Plugin zum Verwalten von Photoalben
* 
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
* @version              $Id: MyPhotoPlugin.class.php 1193 2007-05-11 17:06:14Z jankul $
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// statistics.php
// Copyright (C) 2007 Jan Kulmann <jankul@zmml.uni-bremen.de>
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+

require_once("Photo.class.php");
require_once("Album.class.php");
require_once("Comment.class.php");
require_once("Controller.class.php");
require_once ($GLOBALS['ABSOLUTE_PATH_STUDIP']."functions.php");
require_once ($GLOBALS['ABSOLUTE_PATH_STUDIP']."messaging.inc.php");

class MyPhotoPlugin extends AbstractStudIPHomepagePlugin {

	var $view;
	var $items_per_page = 16;

	function MyPhotoPlugin(){
		parent::AbstractStudIPHomepagePlugin();
		$this->setPluginIconName('shine.gif');
	}
	
	function setPluginpath($newpath){
		parent::setPluginpath($newpath);
		$this->buildMenu();
	}

	function setRequestedUser($user) {
		parent::setRequestedUser($user);
		$u = $this->getRequestedUser();
		$c = new Controller();
		$this->setStatusShowOverviewPage($c->get_public_viewable_album_count($u->getUserId()));
	}
	
	function buildMenu(){
		$tab = new PluginNavigation();
		$tab->setDisplayname(_("MyPhotos"));
		$tab->setActive();
		$subnav = new PluginNavigation();
		$subnav->setDisplayname(_("Neues Album"));
		$subnav->setActive();
		$subnav->setLinkParam("new_album");
		$tab->addSubmenu($subnav);
		/*$subnav2 = new PluginNavigation();
		$subnav2->setDisplayname(_("Photos hinzuf&uuml;gen"));
		$subnav2->setActive();
		$subnav2->setLinkParam("new_photos");
		$tab->addSubmenu($subnav2);*/
		$this->setNavigation($tab); 
	}


	function get_scriptaculous() {
		echo "<script src=\"".$this->getPluginpath()."/scriptaculous/prototype.js\" type=\"text/javascript\"></script>\n";
		echo "<script src=\"".$this->getPluginpath()."/scriptaculous/scriptaculous.js\" type=\"text/javascript\"></script>\n";
	}

	function createInfoBox ($imgLogo) {
		$u = $this->getRequestedUser();
		$c = new Controller();
		$quota_size = $c->get_absolut_content_size_in_db($u->getUserId());
		$quota = $c->translate_disksize($quota_size);
		if ($quota_size > $c->max_quota_size)
			$quota = "<FONT COLOR=\"RED\">$quota</FONT>";
		else
			$quota = "<FONT COLOR=\"GREEN\">$quota</FONT>";
		$info1 =  array ("icon" => "i.gif", "text" => _("Mit MyPhotos k&ouml;nnen sehr schnell Fotoalben angelegt werden."));
		$info2 =  array ("icon" => "eigene2.gif", "text" => _("Jedes Album und jedes Foto kann individuell beschrieben werden."));
		$info3 =  array ("icon" => "icon-guest.gif", "text" => _("Mit der integrierten Kommentarfunktion werden Einrd&uuml;cke ausgetauscht."));
		$info4 =  array ("icon" => "calendar_public.gif", "text" => _("Jedes Album kann separat sichtbar oder unsichtbar f&uuml;r andere geschaltet werden. Der Eigentmer eines Album entscheidet selbst, ob Kommentare zu einzelnen Fotos erlaubt sein sollen."));
		$info5 =  array ("icon" => "cont_folder_add.gif", "text" => _("&Uuml;ber die ZIP-Uploadfunktion werden Bildersammlungen bequem hochgeladen."));
		$info6 =  array ("icon" => "zip-icon.gif", "text" => _(sprintf("Speicherverbrauch: <BR><B>%s</B> von <B>%s</B>",$quota,$c->translate_disksize($c->max_quota_size))));
		$info7 =  array ("icon" => "rewind.gif", "text" => _("Innerhalb eines Albums k&ouml;nnen Fotos per drag and drop sortiert werden."));
		$infobox = array (array ("kategorie" => _("Information:"), "eintrag"   => array ($info1,$info2,$info3,$info4,$info5,$info7,$info6)));
		return print_infobox ($infobox, $imgLogo, YES);
	}

	function showOverview() {
		$this->view = "showOverview";
		$modus = $_REQUEST['modus'];
		if ($modus != "") {
			if ($modus == "view_album") {
		                $this->public_view_album($_REQUEST['album_id']);
                	}
			if ($modus == "make_comment") {
                                $co = new Comment();
                                $co->set_photo_id($_REQUEST['photo_id']);
                                $co->set_user_id($GLOBALS['auth']->auth['uid']);
                                $co->set_mkdate(time());
                                $co->set_comment($_REQUEST['comment']);
                                $co->save();
				$p = new Photo();
				$p->load($_REQUEST['photo_id']);
				$a = new Album();
				$a->load($p->get_album_id());
				$messaging=new messaging;
				$msg = sprintf("%s hat ein Foto in Deinem Album \"%s\" kommentiert.",get_vorname($GLOBALS['auth']->auth["uid"]),$a->get_titel());
				$messaging->insert_message($msg, get_username($p->get_user_id()), $GLOBALS['auth']->auth["uid"], FALSE, FALSE, 1, FALSE, _("Foto-Kommentar"));
                                $modus = "show_photo_maxsize";
                        }
			if ($modus == "show_photo_maxsize") {
				$this->public_show_foto_maxsize($_REQUEST['photo_id']);
			}
		} else
			$this->public_show_albums(TRUE);
	}

	function new_album() {
		echo "<TABLE BORDER=\"0\" WIDTH=\"100%\">\n";
                echo "  <TR>\n";
                echo "    <TD VALIGN=\"TOP\" CLASS=\"blank\">\n";

		echo "<FORM NAME=\"new_album\" METHOD=\"POST\" ACTION=\"".PluginEngine::getLink($this,array())."\">\n";
		echo "  <INPUT TYPE=\"hidden\" NAME=\"modus\" VALUE=\"add_album\">\n";
		echo "<CENTER><DIV STYLE=\"width:400px; margin:25px; padding:5px; border-color:red; border-width:thin; border-style:solid\">\n";
		echo "  <TABLE BORDER=\"0\" ALIGN=\"center\">\n";
		echo "    <TR>\n";
		echo "      <TD><FONT SIZE=\"-1\"><B>Titel:</B></FONT></TD>\n";
		echo "      <TD><INPUT TYPE=\"text\" NAME=\"titel\" STYLE=\"width:265px\" MAXLENGTH=\"255\"></TD>\n";
		echo "    </TR>\n";
		echo "    <TR>\n";
		echo "      <TD><FONT SIZE=\"-1\"><B>Untertitel:</B></FONT></TD>\n";
		echo "      <TD><INPUT TYPE=\"text\" NAME=\"untertitel\" STYLE=\"width:265px\" MAXLENGTH=\"255\"></TD>\n";
		echo "    </TR>\n";
		echo "    <TR>\n";
		echo "      <TD VALIGN=\"TOP\"><FONT SIZE=\"-1\"><B>Beschreibung:</B></FONT></TD>\n";
		echo "      <TD><TEXTAREA NAME=\"beschreibung\" STYLE=\"width:265px; height:100px\"></TEXTAREA></TD>\n";
		echo "    </TR>\n";
		echo "    <TR>\n";
		echo "      <TD COLSPAN=\"2\" ALIGN=\"center\">\n";
		echo "        <TABLE BORDER=\"0\"><TR>\n";
		echo "          <TD ALIGN=\"center\"><INPUT TYPE=\"image\" ".makeButton("anlegen","src")."></TD>\n";
		echo "          <TD ALIGN=\"center\"><A HREF=\"".PluginEngine::getLink($this,array())."\"><IMG ".makeButton("abbrechen","src")." BORDER=\"0\"></A></TD>\n";
		echo "        </TR></TABLE>\n";
		echo "      </TD>\n";
		echo "    </TR>\n";
		echo "  </TABLE>\n";
		echo "</DIV></CENTER>";
		echo "</FORM>\n";

		echo "    </TD>\n";
                echo "    <TD CLASS=\"blank\" WIDTH=\"2%\" ALIGN=\"CENTER\" VALIGN=\"TOP\">".$this->createInfoBox("modules.jpg")."</TD>\n";
                echo "  </TR>\n";
                echo "</TABLE>\n";
	}
	
	function public_view_album($album_id) {
		global $PHP_SELF;
		echo "<A NAME=\"anker\">\n";

		$page = ($_REQUEST['page'] ? $_REQUEST['page'] : 1);

		$a = new Album();
		$a->load($album_id);
		$c = new Controller();
		$u = $this->getRequestedUser();
		//$photos = $c->get_all_photos_in_album($GLOBALS['auth']->auth['uid'], $album_id);
		$photos = $c->get_all_photos_in_album($u->getUserId(), $album_id);

		$photo_count = count($photos);

		if ($photo_count > 0) {
			echo "<A HREF=\"$PHP_SELF?username=".$u->getUserName()."#anker\">".makeButton("zurueck","img")."</A>\n";
			$count = 0;
			echo "<TABLE BORDER=\"0\" ALIGN=\"center\">\n";
			echo "  <TR>\n";
			echo "    <TD COLSPAN=\"4\" ALIGN=\"center\"><B>".htmlReady($a->get_titel())."</B></TD>\n";
			echo "  </TR>\n";
			if ($a->get_untertitel() != "") {
				echo "  <TR>\n";
				echo "    <TD COLSPAN=\"4\" ALIGN=\"center\"><FONT SIZE=\"-1\"><B>".htmlReady($a->get_untertitel())."</B></FONT></TD>\n";
				echo "  </TR>\n";
			}
			if ($a->get_beschreibung() != "") {
				echo "  <TR>\n";
				echo "    <TD COLSPAN=\"4\" ALIGN=\"center\"><FONT SIZE=\"-1\"><B>".formatReady($a->get_beschreibung())."</B></FONT></TD>\n";
				echo "  </TR>\n";
			}
			echo "  <TR>\n";
			echo "    <TD COLSPAN=\"4\" ALIGN=\"right\">\n";
			if ($photo_count > $this->items_per_page) {
				for ($i=1; $i <= ceil(($photo_count / $this->items_per_page)); $i++)
					if ($page == $i)
						echo "<FONT SIZE=\"-2\">&nbsp;[$i]</FONT>\n";
					else
						echo "<FONT SIZE=\"-2\">&nbsp;<A HREF=\"$PHP_SELF?modus=view_album&album_id=".$a->get_album_id()."&username=".$u->getUserName()."&page=$i#anker\">$i</A></FONT>\n";
			} else echo "&nbsp;\n";
			echo "    </TD>\n";
			echo "  </TR>\n";
			echo "</TABLE>\n";

			$skipped = 0;
			$shown = 0;
			echo "<CENTER>\n";
			echo "<DIV STYLE=\"width:800px;\">\n";
			foreach ($photos as $p) {
				if ($page > 1 && $skipped != (($page-1) * $this->items_per_page)) {
					$skipped++;
					continue;
				}
				if ($shown == $this->items_per_page)
					continue;
				/*if ($count == 0) {
					echo "  <TR>\n";
				}*/
				
				$shown++;

				$comment_count = $c->get_number_of_all_photo_comments($p->get_photo_id());

				//echo "    <TD WIDTH=\"160px\" VALIGN=\"TOP\" ALIGN=\"CENTER\">\n";
				echo "      <DIV STYLE=\"float:left; overflow:hidden; text-align:center; width:170px; height:170px; max-width:170px; max-height:170px; margin:5px; padding:1px; border-color:gray; border-width:1px; border-style:solid\">\n";
				// echo "        <A HREF=\"".PluginEngine::getLink($this,array("photo_id"=>$p->get_photo_id(), "modus"=>"show_photo_maxsize"),$this->view)."\"><IMG SRC=\"".$GLOBALS['ABSOLUTE_URI_STUDIP']."plugins/packages/ZMML/MyPhotoPlugin/download.php?modus=thumb&photo_id=".$p->get_photo_id()."\" BORDER=\"0\" ALT=\"".htmlReady($p->get_titel())."\" TITLE=\"".htmlReady($p->get_titel())."\"></A><BR>";
				//echo "        <A HREF=\"$PHP_SELF?photo_id=".$p->get_photo_id()."&modus=show_photo_maxsize&username=".$u->getUserName()."#anker\"><IMG SRC=\"".$GLOBALS['ABSOLUTE_URI_STUDIP']."plugins/packages/ZMML/MyPhotoPlugin/download.php?modus=thumb&photo_id=".$p->get_photo_id()."\" BORDER=\"0\" ALT=\"".htmlReady($p->get_titel())."\" TITLE=\"".htmlReady($p->get_titel())."\"></A>";
				echo "        <DIV STYLE=\"clear:both; position:relative; height:130px; text-align:center;\">\n";
				echo "          <A HREF=\"$PHP_SELF?photo_id=".$p->get_photo_id()."&modus=show_photo_maxsize&username=".$u->getUserName()."#anker\">";
				echo "<IMG SRC=\"".$GLOBALS['ABSOLUTE_URI_STUDIP'].$this->getPluginpath()."/download.php?modus=thumb&photo_id=".$p->get_photo_id()."\" BORDER=\"0\" ALT=\"".htmlReady($p->get_titel())."\" TITLE=\"".htmlReady($p->get_titel())."\" STYLE=\"position:absolute; top:1px; left:25px; clip:rect(0px, 120px, 120px, 0px);\">";
				echo "</A>";
				echo "        </DIV>\n";
				echo "        <DIV STYLE=\"clear:both; position:relative; text-align:center;\">\n";
				if (strlen($p->get_titel()) > 0)
					echo "        <FONT SIZE=\"-2\">".(htmlReady(strlen($p->get_titel())>30 ? substr($p->get_titel(),0,30)."..." : $p->get_titel()))."</FONT><BR>\n";
				if ($comment_count > 0)
                                        echo "        <FONT SIZE=\"-2\">$comment_count Kommentar".($comment_count>1?"e":"")."</FONT>\n";
				echo "        </DIV>\n";
				echo "      </DIV>\n";
				//echo "    </TD>\n";
				$count++;
				/*if ($count == 4) {
					echo "  </TR>\n";
					$count = 0;
				}*/
			}
			echo "</DIV>\n";
			/*if ($count != 4 && $count!=0) {
                                for ($i=$count+1; $i<5; $i++) {
                                        echo "    <TD VALIGN=\"TOP\" ALIGN=\"CENTER\"><FONT SIZE=\"-1\">&nbsp;</FONT></TD>\n";
                                }
                                echo "  </TR>\n";
                        }*/
			echo "</CENTER>\n";
			//echo "</TABLE>\n";
			//echo "</DIV></CENTER>\n";
		}

	}
	
	function admin_view_album($album_id) {
		$a = new Album();
		$a->load($album_id);
		$c = new Controller();
		$u = $this->getRequestedUser();
		//$photos = $c->get_all_photos_in_album($GLOBALS['auth']->auth['uid'], $album_id);
		$photos = $c->get_all_photos_in_album($u->getUserId(), $album_id);

		$this->get_scriptaculous();

		echo "<TABLE BORDER=\"0\" WIDTH=\"100%\">\n";
                echo "  <TR>\n";
                echo "    <TD VALIGN=\"TOP\" CLASS=\"blank\">\n";

		echo "<A HREF=\"".PluginEngine::getLink($this,array())."\">".makeButton("zurueck","img")."</A>\n";

		/*echo "<FORM NAME=\"new_fotos\" METHOD=\"POST\" ACTION=\"".PluginEngine::getLink($this,array())."\">\n";
		echo "<CENTER><DIV STYLE=\"width:400px; margin:25px; padding:5px; border-color:red; border-width:thin; border-style:solid\">\n";
		echo "<TABLE BORDER=\"0\">\n";
		echo "  <TR><TD><FONT SIZE=\"-1\"><B>Fotos</B></FONT></TD>\n";
		echo "  <INPUT TYPE=\"hidden\" NAME=\"modus\" VALUE=\"add_photos\">\n";
		echo "  <INPUT TYPE=\"hidden\" NAME=\"album_id\" VALUE=\"$album_id\">\n";
		echo "  <TD><INPUT TYPE=\"image\" ".makeButton("hinzufuegen","src")."></TD>\n";
		echo "</TR></TABLE>\n";
		echo "</DIV></CENTER>\n";
		echo "</FORM>\n";*/


/*?><script type="text/javascript" language="javascript">
var show_album_edit = false;
</script><?*/
		echo "<CENTER>\n";
	       	/*echo "  <DIV ID=\"album_hint\" STYLE=\"margin:30px;\">\n";
	        echo "  <DIV>\n";
		if ($a->get_titel() == "")
			echo "<SPAN STYLE=\"font-size:x-small\">&lt;Kein Titel vorhanden&gt;</SPAN><BR>\n";
		else
			echo htmlReady($a->get_titel())."<BR>\n";
		if ($a->get_beschreibung() == "")
			echo "<SPAN STYLE=\"font-size:x-small\">&lt;Keine Beschreibung vorhanden&gt;</SPAN><BR>\n";
		else
			echo htmlReady($a->get_beschreibung())."<BR>\n";
		echo "    <BR><BR>\n";
		echo "  </DIV>\n";
		//echo "  <A STYLE=\"font-size:smaller;\" HREF=\"javascript:void(0);\" onClick=\"if (!show_album_edit){new Effect.SlideUp('album_hint');new Effect.SlideDown('album_edit');show_album_edit=true;}\" onMouseOver=\"if (!show_album_edit){new Effect.SlideUp('album_hint');new Effect.SlideDown('album_edit');show_album_edit=true;}\">Album bearbeiten&nbsp;<IMG SRC=\"".$GLOBALS['ASSETS_URL']."images/move_down.gif\" BORDER=0></A>\n";
	        echo "  </DIV>\n";*/

		//echo "<DIV ID=\"album_edit\" STYLE=\"display:none;\">\n";
		echo "<DIV ID=\"album_edit\">\n";
		echo "<FORM NAME=\"edit_album\" METHOD=\"POST\" ACTION=\"".PluginEngine::getLink($this,array())."\">\n";
		echo "  <INPUT TYPE=\"hidden\" NAME=\"sortierung\" VALUE=\"\">\n";
		echo "  <INPUT TYPE=\"hidden\" NAME=\"modus\" VALUE=\"save_album\">\n";
		echo "  <INPUT TYPE=\"hidden\" NAME=\"album_id\" VALUE=\"$album_id\">\n";
		echo "  <INPUT TYPE=\"hidden\" NAME=\"photo_id\" VALUE=\"".$a->get_start_photo_id()."\">\n";
		echo "<DIV STYLE=\"width:600px; margin:25px; padding:5px; border-color:red; border-width:thin; border-style:solid\">\n";
		echo "  <TABLE BORDER=\"0\" ALIGN=\"center\" WIDTH=\"600px\">\n";
		echo "    <TR><TD COLSPAN=\"2\" ALIGN=\"center\"><FONT SIZE=\"-1\" COLOR=\"gray\"><B>Album-Informationen</B></FONT></TD></TR>\n";
		echo "    <TR>\n";
		echo "      <TD><FONT SIZE=\"-1\"><B>Titel:</B></FONT></TD>\n";
		echo "      <TD><INPUT TYPE=\"text\" NAME=\"titel\" VALUE=\"".htmlReady($a->get_titel())."\" STYLE=\"width:400px\" MAXLENGTH=\"255\"></TD>\n";
		echo "    </TR>\n";
		echo "    <TR>\n";
		echo "      <TD><FONT SIZE=\"-1\"><B>Untertitel:</B></FONT></TD>\n";
		echo "      <TD><INPUT TYPE=\"text\" NAME=\"untertitel\" VALUE=\"".htmlReady($a->get_untertitel())."\" STYLE=\"width:400px\" MAXLENGTH=\"255\"></TD>\n";
		echo "    </TR>\n";
		echo "    <TR>\n";
		echo "      <TD VALIGN=\"TOP\"><FONT SIZE=\"-1\"><B>Beschreibung:</B></FONT></TD>\n";
		echo "      <TD><TEXTAREA NAME=\"beschreibung\" STYLE=\"width:400px; height:150px\">".htmlReady($a->get_beschreibung())."</TEXTAREA></TD>\n";
		echo "    </TR>\n";
		echo "    <TR>\n";
		echo "      <TD VALIGN=\"TOP\"><FONT SIZE=\"-1\"><B>F&uuml;r andere sichtbar:</B></FONT></TD>\n";
		echo "      <TD><INPUT TYPE=\"radio\" NAME=\"public\" VALUE=\"1\" ".($a->get_public() == 1 ? "CHECKED" : "")."><FONT SIZE=\"-1\">Ja</FONT>  \n";
		echo "          <INPUT TYPE=\"radio\" NAME=\"public\" VALUE=\"0\" ".($a->get_public() == 0 ? "CHECKED" : "")."><FONT SIZE=\"-1\">Nein</FONT></TD>\n";
		echo "    </TR>\n";
		echo "    <TR>\n";
		echo "      <TD VALIGN=\"TOP\"><FONT SIZE=\"-1\"><B>Kommentare zulassen:</B></FONT></TD>\n";
		echo "      <TD><INPUT TYPE=\"radio\" NAME=\"allow_comments\" VALUE=\"1\" ".($a->get_allow_comments() == 1 ? "CHECKED" : "")."><FONT SIZE=\"-1\">Ja</FONT>  \n";
		echo "          <INPUT TYPE=\"radio\" NAME=\"allow_comments\" VALUE=\"0\" ".($a->get_allow_comments() == 0 ? "CHECKED" : "")."><FONT SIZE=\"-1\">Nein</FONT></TD>\n";
		echo "    </TR>\n";
		/*echo "    <TR>\n";
		echo "      <TD COLSPAN=\"2\" ALIGN=\"center\"><INPUT TYPE=\"image\" ".makeButton("speichern","src").">\n";
		echo "        <A HREF=\"".PluginEngine::getLink($this,array("modus"=>"del_album","album_id"=>$a->get_album_id()))."\" onClick=\"return confirm('Soll das Album wirklich gel&ouml;scht werden?');\"><IMG BORDER=\"0\" ".makeButton("loeschen","src")."></A>\n";
		echo "      </TD>\n";
		echo "    </TR>\n";
		echo "    <TR><TD COLSPAN=\"2\" ALIGN=\"center\"><p id=\"sortinfo\" STYLE=\"color:red; font-weight:bold;\"></p></TD></TR>\n";*/
		echo "    <TR><TD COLSPAN=\"2\" ALIGN=\"center\"><SPAN STYLE=\"font-weight:bold; font-size:smaller;\"><IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/cont_folder_add.gif\" BORDER=\"0\"> <A HREF=\"".PluginEngine::getLink($this,array("modus"=>"add_photos", "album_id"=>$album_id))."\">Fotos hinzuf&uuml;gen</A></SPAN></TD></TR>\n";
		echo "  </TABLE>\n";
		echo "</DIV>\n";
		echo "</DIV>\n";

		echo "<DIV>\n";
		echo "  <INPUT TYPE=\"image\" ".makeButton("speichern","src").">\n";
		echo "  <A HREF=\"".PluginEngine::getLink($this,array("modus"=>"del_album","album_id"=>$a->get_album_id()))."\" onClick=\"return confirm('Soll das Album wirklich gel&ouml;scht werden?');\"><IMG BORDER=\"0\" ".makeButton("loeschen","src")."></A><BR>\n";
		echo "  <p id=\"sortinfo\" STYLE=\"color:red; font-weight:bold;\"></p>\n";
		echo "</DIV>\n";

		echo "</CENTER>\n";


		if (count($photos) > 0) {
			$count = 0;
			echo "<CENTER>\n";
			echo "<DIV id=\"photos\" STYLE=\"width:800px\">\n";
			//echo "<TABLE BORDER=\"0\" ALIGN=\"center\">\n";
			foreach ($photos as $p) {
				/*if ($count == 0) {
					echo "  <TR>\n";
				}*/

				$comment_count = $c->get_number_of_all_photo_comments($p->get_photo_id());

				//echo "    <TD WIDTH=\"160px\" VALIGN=\"TOP\" ALIGN=\"CENTER\" id=\"photo_cell\">\n";
				//echo "      <SPAN STYLE=\"text-align:center; width:160px; height:220px; margin:1px; padding:1px; border-color:black; border-width:thin; border-style:solid\">\n";
				//echo "      <DIV id=\"bla_".$p->get_photo_id()."\" STYLE=\"float:left; border-color:black; border-width:thin; border-style:solid; max-height:220px; max-width:160px; height:220px; width:160px; background-image:url(".$this->getPluginpath()."/transparent_border.gif);\">\n";
				echo "      <DIV id=\"bla_".$p->get_photo_id()."\" STYLE=\"float:left; overflow:hidden; padding:1px; margin:5px; border-color:gray; border-width:1px; border-style:solid; max-height:180px; max-width:180px; height:180px; width:180px;\">\n";
				echo "      <DIV STYLE=\"clear:both; text-align:center;\">\n";
				echo "        <INPUT TYPE=\"radio\" NAME=\"tmp_photo_id\" VALUE=\"".$p->get_photo_id()."\" ".($a->get_start_photo_id() == $p->get_photo_id() ? "CHECKED" :"")." onClick=\"document.edit_album.photo_id.value='".$p->get_photo_id()."';\" onChange=\"$('sortinfo').innerHTML = 'Speichern nicht vergessen!';\">\n";
				echo "      </DIV>\n";
				echo "      <DIV STYLE=\"clear:both; position:relative; height:120px; text-align:center;\">\n";
				//echo "        <FONT SIZE=\"-1\">\n";
				//echo "        <A id=\"photolink_".$p->get_photo_id()."\" HREF=\"".PluginEngine::getLink($this,array("photo_id"=>$p->get_photo_id(), "modus"=>"show_photo_maxsize"),$this->view)."\" onClick=\"return sortableReordered;\"><IMG STYLE=\"position:absolute; top:25px; left:15px; clip:rect(0px, 130px, 130px, 0px);\" SRC=\"".$GLOBALS['ABSOLUTE_URI_STUDIP'].$this->getPluginpath()."/download.php?modus=thumb&photo_id=".$p->get_photo_id()."\" BORDER=\"0\" ALT=\"".htmlReady($p->get_titel())."\" TITLE=\"".htmlReady($p->get_titel())."\"></A>";
				echo "        <A id=\"photolink_".$p->get_photo_id()."\" HREF=\"".PluginEngine::getLink($this,array("photo_id"=>$p->get_photo_id(), "modus"=>"show_photo_maxsize"),$this->view)."\" onClick=\"return sortableReordered;\">";
				echo "<IMG ID=\"img_".$p->get_photo_id()."\" STYLE=\"position:absolute; top:1px; left:30px; clip:rect(0px, 120px, 120px, 0px);\" SRC=\"".$GLOBALS['ABSOLUTE_URI_STUDIP'].$this->getPluginpath()."/download.php?modus=thumb&photo_id=".$p->get_photo_id()."\" BORDER=\"0\" ALT=\"".htmlReady($p->get_titel())."\" TITLE=\"".htmlReady($p->get_titel())."\" onMouseOver=\"sortableReordered=true;\">";
				echo "</A>\n";
				?>
	<script type=\"text/javascript" language="javascript">
	Event.observe('photolink_<?=$p->get_photo_id()?>', 'click', function(event) { checkSortable(event); });
	</script>
				<?
				echo "\n";
				echo "      </DIV>\n";
				//echo "        </FONT>\n";
				echo "      <DIV STYLE=\"clear:both; position:relative; text-align:center;\">\n";
				if (strlen($p->get_titel()) > 0) {
					echo "        <FONT SIZE=\"-2\">".(htmlReady(strlen($p->get_titel())>30 ? substr($p->get_titel(),0,30)."..." : $p->get_titel()))."</FONT><BR>\n";
				}
				if ($comment_count > 0) {
					echo "        <FONT SIZE=\"-2\">$comment_count Kommentar".($comment_count>1?"e":"")."</FONT>\n";
				}
				echo "      </DIV>\n";
				echo "      </DIV>\n";
				//echo "    </TD>\n";
				$count++;
				/*if ($count == 4) {
					echo "  </TR>\n";
					$count = 0;
				}*/
			}
			/*if ($count != 4 && $count!=0) {
                                for ($i=$count+1; $i<5; $i++) {
                                        echo "    <TD VALIGN=\"TOP\" ALIGN=\"CENTER\"><FONT SIZE=\"-1\">&nbsp;</FONT></TD>\n";
                                }
                                echo "  </TR>\n";
                        }
			echo "</TABLE>\n";*/
			echo "</DIV>\n";
			echo "</CENTER>\n";
		}
		
		?>
 <!--p>
    <span id="sortinfo"></span>
 </p -->

<script type="text/javascript" language="javascript">
 // <![CDATA[
   sortableReordered = true;

function checkSortable(event)
{
    if (sortableReordered) {
         Event.stop(event);
         sortableReordered = false;
    }
}

   Sortable.create("photos",
     {tag:'div',overlap:'horizontal',constraint: false,
      onUpdate:function(){
	sortableReordered = false;
	document.edit_album.sortierung.value = Sortable.serialize("photos");
	new Ajax.Request("<?=$GLOBALS['ABSOLUTE_URI_STUDIP'].$this->getPluginpath()?>/update_sort.php?album_id=<?=$a->get_album_id()?>",
        {
            method: "post",
            parameters: { sortierung: Sortable.serialize("photos") },
	    onFailure: function(t) {alert('Error ' + t.status + ' -- ' + t.statusText); },
	    /*onSuccess: function(t) {alert(t.responseText); },*/
	    on404: function(t) {alert('Error 404: location "' + t.statusText + '" was not found.'); }
        }
        );
        /*p = $("photos");
        p.moves = p.moves || 0;
        p.moves++;*/
        /*$('sortinfo').innerHTML = "Speichern nicht vergessen!";*/
        /*if(Sortable.serialize("photos")==
           "photos[]=1&photos[]=2&photos[]=3&" +
           "photos[]=4&photos[]=5&photos[]=6&" +
           "photos[]=7&photos[]=8&photos[]=9") {
           $('puzzleinfo').innerHTML =
             "You've solved the puzzle in " + p.moves + " moves!";
           Element.Class.add('puzzleinfo','congrats');
        }*/
      }
    })
 // ]]>
 </script>
<?

		echo "</FORM>\n";

		echo "    </TD>\n";
                echo "    <TD CLASS=\"blank\" WIDTH=\"2%\" ALIGN=\"CENTER\" VALIGN=\"TOP\">".$this->createInfoBox("modules.jpg")."</TD>\n";
                echo "  </TR>\n";
                echo "</TABLE>\n";

	}

	function public_show_foto_maxsize($photo_id) {
		global $PHP_SELF;
		echo "<A NAME=\"anker\">\n";

		$this->get_scriptaculous();

		$u = $this->getRequestedUser();

		$p = new Photo();
		$p->load($photo_id);

		$a = new Album();
		$a->load($p->get_album_id());
	
	        echo "<CENTER>\n";
	        echo "<TABLE BORDER=\"0\" WIDTH=\"98%\" CELLSPACING=\"0\" CELLPADDING=\"1\">\n";
	
	        echo "  <TR>\n";
	        echo "    <TD ALIGN=\"left\">&nbsp;<A HREF=\"$PHP_SELF?username=".$u->getUserName()."&modus=view_album&album_id=".$p->get_album_id()."#anker\">".makeButton("zurueck","img")."</A></TD>\n";
	        echo "  </TR>\n";

		echo "  <TR>\n";
		echo "    <TD ALIGN=\"center\" STYLE=\"font-size:smaller;\">\n";
		$prev_id = Album::get_prev_photo_id($p->get_album_id(), $p->get_photo_id());
		$next_id = Album::get_next_photo_id($p->get_album_id(), $p->get_photo_id());
		if ($prev_id)
			echo "     <A HREF=\"$PHP_SELF?photo_id=".$prev_id."&modus=show_photo_maxsize&username=".$u->getUserName()."#anker\">"._("voriges Foto")."</A>\n";
		if ($prev_id && $next_id)
			echo "     &nbsp;|&nbsp;\n";
		if ($next_id)
			echo "     <A HREF=\"$PHP_SELF?photo_id=".$next_id."&modus=show_photo_maxsize&username=".$u->getUserName()."#anker\">"._("n&auml;chstes Foto")."</A>\n";
		echo "    </TD>\n";
		echo "  </TR>\n";	

	        echo "  <TR>\n";
	        echo "    <TD ALIGN=\"center\"><B>".htmlReady($p->get_titel())."</B><BR><FONT SIZE=\"-2\">von <A HREF=\"about.php?username=".get_username($p->get_user_id())."\">".get_fullname($p->get_user_id())."</A></FONT></TD>\n";
		echo "  </TR>\n";
	        
	        echo "  <TR>\n";
	        echo "    <TD ALIGN=\"center\"><FONT SIZE=\"-1\">&nbsp;</FONT></TD>\n";
	        echo "  </TR>\n";
	        echo "  <TR>\n";
	        // echo "    <TD CLASS=\"steel1\" ALIGN=\"center\"><IMG SRC=\"sendfile.php?type=7&file_id=foto_".$p->get_file_id().".".$p->get_ext()."&file_name=foto_".$p->get_file_id().".".$p->get_ext()."\" TITEL=\"".htmlReady($p->get_titel())."\" ALT=\"".htmlReady($p->get_titel())."\"></TD>\n";
	        //echo "    <TD ALIGN=\"center\"><IMG SRC=\"".$GLOBALS['ABSOLUTE_URI_STUDIP']."plugins/packages/ZMML/MyPhotoPlugin/download.php?modus=max&photo_id=".$p->get_photo_id()."\" BORDER=\"0\" ALT=\"".htmlReady($p->get_titel())."\" TITLE=\"".htmlReady($p->get_titel())."\"></TD>\n";
	        echo "    <TD ALIGN=\"center\"><IMG SRC=\"".$GLOBALS['ABSOLUTE_URI_STUDIP'].$this->getPluginpath()."/download.php?modus=max&photo_id=".$p->get_photo_id()."\" BORDER=\"0\" ALT=\"".htmlReady($p->get_titel())."\" TITLE=\"".htmlReady($p->get_titel())."\"></TD>\n";
	        echo "  </TR>\n";
	        echo "  <TR>\n";
	        echo "    <TD ALIGN=\"center\"><FONT SIZE=\"-1\">&nbsp;</FONT></TD>\n";
	        echo "  </TR>\n";
	        echo "  <TR>\n";
	        echo "    <TD ALIGN=\"center\"><SPAN STYLE=\"max-width:600px; width:600px; text-align:left; font-size:smaller;\">".formatReady($p->get_beschreibung())."</SPAN></TD>\n";
	        echo "  </TR>\n";
	
	        echo "  <TR>\n";
	        echo "    <TD ALIGN=\"center\"><FONT SIZE=\"-1\">&nbsp;</FONT></TD>\n";
	        echo "  </TR>\n";
		echo "</TABLE>\n";	
	
		if ($a->get_allow_comments() == 1) {
?><script type="text/javascript" language="javascript">
var show_comment_add = false;
</script><?
	        	echo "  <DIV ID=\"comment_hint\">\n";
		        echo "    <A STYLE=\"font-size:smaller;\" HREF=\"javascript:void(0);\" onClick=\"if (!show_comment_add){new Effect.SlideUp('comment_hint');new Effect.SlideDown('comment_add');show_comment_add=true;}\" onMouseOver=\"if (!show_comment_add){new Effect.SlideUp('comment_hint');new Effect.SlideDown('comment_add');show_comment_add=true;}\">Kommentar schreiben&nbsp;<IMG SRC=\"".$GLOBALS['ASSETS_URL']."images/move_down.gif\" BORDER=0></A>\n";
		        echo "  </DIV>\n";
			
			echo "  <DIV ID=\"comment_add\" STYLE=\"display:none;\">\n";
		        echo "  <FORM NAME=\"add_comment\" METHOD=\"POST\" ACTION=\"$PHP_SELF?username=".$u->getUserName()."#anker\">\n";
		        echo "    <INPUT TYPE=\"hidden\" NAME=\"modus\" VALUE=\"make_comment\">\n";
	        	echo "    <INPUT TYPE=\"hidden\" NAME=\"photo_id\" VALUE=\"".$p->get_photo_id()."\">\n";
		        echo "    <TABLE BORDER=\"0\"><TR><TD><B><FONT SIZE=\"-1\">Kommentieren:&nbsp;</FONT></B><INPUT TYPE=\"TEXT\" NAME=\"comment\" VALUE=\"\" SIZE=\"50\" MAXLENGTH=\"255\">&nbsp;</TD><TD><INPUT TYPE=\"image\" ".makeButton("abschicken","SRC")."></TD></TR></TABLE>\n";
		        echo "  </FORM>\n";
			echo "  </DIV>\n";
		}
	        echo "</CENTER>\n";

		if ($a->get_allow_comments() == 1) {
			$c = new Controller();		
			$comments = $c->get_all_photo_comments($p->get_photo_id());
			if (count($comments) > 0) {
				//echo "<TABLE BORDER=\"0\" WIDTH=\"50%\" ALIGN=\"center\">\n";
				echo "<CENTER>\n";
				foreach ($comments as $comment) {
					//echo "  <TR>\n";
		                        //echo "    <TD ALIGN=\"left\">\n";
					echo "      <DIV STYLE=\"text-align:left; margin:5px; padding:5px; border-color:black; border-width:1px; border-style:solid; width:50%;\">\n";
					echo "        <FONT SIZE=\"-2\"><A HREF=\"about.php?username=".get_username($comment->get_user_id())."\">".get_fullname($comment->get_user_id())."</A> schrieb am ".date("d.m.Y H:i", $comment->get_mkdate()).":</FONT><FONT SIZE=\"-1\"><BR>".formatReady($comment->get_comment())."</FONT>\n";
					echo "      </DIV>\n";
        	                	//echo "    </TD>\n";
	                	        //echo "  </TR>\n";
				}
				//echo "</TABLE>\n";
				echo "</CENTER>\n";
			}
		}
	}

	function admin_show_foto_maxsize($photo_id) {

		$p = new Photo();
		$p->load($photo_id);

		$a = new Album();
		$a->load($p->get_album_id());

		$this->get_scriptaculous();
	
		echo "<TABLE BORDER=\"0\" WIDTH=\"100%\">\n";
                echo "  <TR>\n";
                echo "    <TD VALIGN=\"TOP\" CLASS=\"blank\">\n";

	        echo "<CENTER>\n";
	        echo "<TABLE BORDER=\"0\" WIDTH=\"98%\" CELLSPACING=\"0\" CELLPADDING=\"1\">\n";
	
	        echo "  <TR>\n";
	        echo "    <TD ALIGN=\"left\">&nbsp;<A HREF=\"".PluginEngine::getLink($this,array("modus"=>"view_album","album_id"=>$a->get_album_id()))."\">".makeButton("zurueck","img")."</A></TD>\n";
	        echo "  </TR>\n";

	        echo "  <TR>\n";
	        echo "    <TD ALIGN=\"center\" STYLE=\"font-size:smaller;\">\n";
		$prev_id = Album::get_prev_photo_id($p->get_album_id(), $p->get_photo_id());
		$next_id = Album::get_next_photo_id($p->get_album_id(), $p->get_photo_id());
		if ($prev_id)
			echo "     <A HREF=\"".PluginEngine::getLink($this,array("photo_id"=>$prev_id, "modus"=>"show_photo_maxsize"),$this->view)."\">"._("voriges Foto")."</A>\n";
		if ($prev_id && $next_id)
			echo "     &nbsp;|&nbsp;\n";
		if ($next_id)
			echo "     <A HREF=\"".PluginEngine::getLink($this,array("photo_id"=>$next_id, "modus"=>"show_photo_maxsize"),$this->view)."\">"._("n&auml;chstes Foto")."</A>\n";
		echo "    </TD>\n";
	        echo "  </TR>\n";
	
	        echo "  <TR>\n";
	        echo "    <TD ALIGN=\"center\"><B>".htmlReady($p->get_titel())."</B><BR><FONT SIZE=\"-2\">von <A HREF=\"about.php?username=".get_username($p->get_user_id())."\">".get_fullname($p->get_user_id())."</A></FONT></TD>\n";
		echo "  </TR>\n";
	        
	        echo "  <TR>\n";
	        echo "    <TD ALIGN=\"center\"><FONT SIZE=\"-1\">&nbsp;</FONT></TD>\n";
	        echo "  </TR>\n";
	        echo "  <TR>\n";
	        // echo "    <TD CLASS=\"steel1\" ALIGN=\"center\"><IMG SRC=\"sendfile.php?type=7&file_id=foto_".$p->get_file_id().".".$p->get_ext()."&file_name=foto_".$p->get_file_id().".".$p->get_ext()."\" TITEL=\"".htmlReady($p->get_titel())."\" ALT=\"".htmlReady($p->get_titel())."\"></TD>\n";
	        // echo "    <TD ALIGN=\"center\"><IMG SRC=\"".$GLOBALS['ABSOLUTE_URI_STUDIP']."plugins/packages/ZMML/MyPhotoPlugin/download.php?modus=max&photo_id=".$p->get_photo_id()."\" BORDER=\"0\" ALT=\"".htmlReady($p->get_titel())."\" TITLE=\"".htmlReady($p->get_titel())."\"></TD>\n";
	        echo "    <TD ALIGN=\"center\"><IMG ID=\"photo\" SRC=\"".$GLOBALS['ABSOLUTE_URI_STUDIP'].$this->getPluginpath()."/download.php?modus=max&photo_id=".$p->get_photo_id()."\" BORDER=\"0\" ALT=\"".htmlReady($p->get_titel())."\" TITLE=\"".htmlReady($p->get_titel())."\"></TD>\n";
	        echo "  </TR>\n";
	        echo "  <TR>\n";
	        echo "    <TD ALIGN=\"center\"><FONT SIZE=\"-1\">&nbsp;</FONT></TD>\n";
	        echo "  </TR>\n";
		echo "</TABLE>\n";

		//echo "  <TR>\n";
		//echo "    <TD ALIGN=\"center\"><FONT SIZE=\"-1\">\n";
/*?><script type="text/javascript" language="javascript">
var show_edit_photo = false;
</script><?*/


		echo "  <DIV STYLE=\"font-size:smaller; max-width:600px; width:600px; text-align:left;\">\n";
		/*if ($p->get_titel() == "")
			echo "<SPAN STYLE=\"font-size:smaller\">&lt;Kein Titel vorhanden&gt;</SPAN><BR>\n";
		else
			echo htmlReady($p->get_titel())."<BR>\n";*/
		if ($p->get_beschreibung() == "")
			echo "<SPAN STYLE=\"font-size:smaller\">&lt;Keine Beschreibung vorhanden&gt;</SPAN><BR>\n";
		else
			echo htmlReady($p->get_beschreibung())."<BR>\n";
		//echo "   <BR>\n";
		//echo "    <A HREF=\"".PluginEngine::getLink($this,array("modus"=>"del_photo","photo_id"=>$p->get_photo_id(),"album_id"=>$p->get_album_id()))."\" onClick=\"return confirm('Soll das Foto wirklich gel&ouml;scht werden?');\"><IMG ".makeButton("loeschen","src")." BORDER=\"0\"></A>\n";
		//echo "   <BR><BR>\n";
		echo "  </DIV>\n";

	       	echo "  <DIV ID=\"edit_hint\">\n";
	        //echo "    <A STYLE=\"font-size:smaller;\" HREF=\"javascript:void(0);\" onClick=\"if (!show_edit_photo){new Effect.SlideUp('edit_hint');new Effect.SlideDown('edit_photo');show_edit_photo=true;}\" onMouseOver=\"if (!show_edit_photo){new Effect.SlideUp('edit_hint');new Effect.SlideDown('edit_photo');show_edit_photo=true;}\">Titel und Beschreibung &auml;ndern&nbsp;<IMG SRC=\"".$GLOBALS['ASSETS_URL']."images/move_down.gif\" BORDER=0></A>\n";
	        echo "  </DIV>\n";

		//echo "    <DIV ID=\"edit_photo\" STYLE=\"display:none;\">\n";
		echo "    <DIV ID=\"edit_photo\">\n";
		echo "      <FORM NAME=\"poto_edit\" METHOD=\"POST\" ACTION=\"".PluginEngine::getLink($this,array())."\">\n";
		echo "      <INPUT TYPE=\"hidden\" NAME=\"modus\" VALUE=\"save_photo\">\n";
		echo "      <INPUT TYPE=\"hidden\" NAME=\"photo_id\" VALUE=\"".$p->get_photo_id()."\">\n";
		echo "      <DIV STYLE=\"width:600px; margin:25px; padding:5px; border-color:red; border-width:thin; border-style:solid\">\n";
		echo "        <TABLE BORDER=\"0\" ALIGN=\"center\">\n";
		echo "          <TR>\n";
		echo "            <TD><FONT SIZE=\"-1\"><B>Titel:</B></FONT></TD>\n";
		echo "            <TD><INPUT TYPE=\"text\" NAME=\"titel\" VALUE=\"".htmlReady($p->get_titel())."\" STYLE=\"width:500px\" MAXLENGTH=\"255\"></TD>\n";
		echo "         </TR>\n";
		echo "         <TR>\n";
		echo "           <TD VALIGN=\"TOP\"><FONT SIZE=\"-1\"><B>Beschreibung:</B></FONT></TD>\n";
		echo "           <TD><TEXTAREA NAME=\"beschreibung\" STYLE=\"width:500px; height:150px\">".htmlReady($p->get_beschreibung())."</TEXTAREA></TD>\n";
		echo "         </TR>\n";
		echo "         <TR>\n";
		echo "           <TD COLSPAN=\"2\" ALIGN=\"center\"><INPUT TYPE=\"image\" ".makeButton("speichern","src").">\n";
		echo "           <A HREF=\"".PluginEngine::getLink($this,array("modus"=>"del_photo","photo_id"=>$p->get_photo_id(),"album_id"=>$p->get_album_id()))."\" onClick=\"return confirm('Soll das Foto wirklich gel&ouml;scht werden?');\"><IMG ".makeButton("loeschen","src")." BORDER=\"0\"></A>\n";
		echo "           </TD>\n";
		echo "         </TR>\n";
		echo "       </TABLE>\n";
		echo "      </DIV>\n";
		echo "      </FORM>\n";
		echo "    </DIV>\n";
		//echo "    </TD>\n";
		//echo "  </TR>\n";
	
	        /*echo "  <TR>\n";
	        echo "    <TD ALIGN=\"center\"><FONT SIZE=\"-1\">&nbsp;</FONT></TD>\n";
	        echo "  </TR>\n";*/
	
		if ($a->get_allow_comments() == 1) {
?><script type="text/javascript" language="javascript">
var show_comment_add = false;
</script><?

	        	echo "  <DIV ID=\"comment_hint\">\n";
		        echo "    <A STYLE=\"font-size:smaller;\" HREF=\"javascript:void(0);\" onClick=\"if (!show_comment_add){new Effect.SlideUp('comment_hint');new Effect.SlideDown('comment_add');show_comment_add=true;}\" onMouseOver=\"if (!show_comment_add){new Effect.SlideUp('comment_hint');new Effect.SlideDown('comment_add');show_comment_add=true;}\">Kommentar schreiben&nbsp;<IMG SRC=\"".$GLOBALS['ASSETS_URL']."images/move_down.gif\" BORDER=0></A>\n";
		        echo "  </DIV>\n";

			echo "  <DIV ID=\"comment_add\" STYLE=\"display:none;\">\n";
		        echo "  <FORM NAME=\"add_comment\" METHOD=\"POST\" ACTION=\"".PluginEngine::getLink($this,array())."\">\n";
		        echo "    <INPUT TYPE=\"hidden\" NAME=\"modus\" VALUE=\"make_comment\">\n";
	        	echo "    <INPUT TYPE=\"hidden\" NAME=\"photo_id\" VALUE=\"".$p->get_photo_id()."\">\n";
		        echo "    <TABLE BORDER=\"0\"><TR><TD><B><FONT SIZE=\"-1\">Kommentieren:&nbsp;</FONT></B><INPUT TYPE=\"TEXT\" NAME=\"comment\" VALUE=\"\" SIZE=\"50\" MAXLENGTH=\"255\">&nbsp;</TD><TD><INPUT TYPE=\"image\" ".makeButton("abschicken","SRC")."></TD></TR></TABLE>\n";
		        echo "  </FORM>\n";
			echo "  </DIV>\n";
		}
	        echo "</CENTER>\n";

		$c = new Controller();		
		$comments = $c->get_all_photo_comments($p->get_photo_id());
		if (count($comments) > 0) {
			//echo "<TABLE BORDER=\"0\" WIDTH=\"50%\" ALIGN=\"center\">\n";
			echo "<CENTER>\n";
			echo "<DIV STYLE=\"width:530px;\">\n";
			foreach ($comments as $comment) {
				//echo "  <TR>\n";
	                        //echo "    <TD ALIGN=\"left\">\n";
				echo "      <DIV STYLE=\"text-align:left; float:left; margin:1px; padding:1px; border-color:black; border-width:thin; border-style:solid; width:500px;\">\n";
				echo "        <FONT SIZE=\"-2\"><A HREF=\"about.php?username=".get_username($comment->get_user_id())."\">".get_fullname($comment->get_user_id())."</A> schrieb am ".date("d.m.Y H:i", $comment->get_mkdate()).":</FONT><BR><FONT SIZE=\"-1\">".formatReady($comment->get_comment())."</FONT>\n";
				echo "      </DIV>\n";
        	                //echo "    </TD>\n";
				//echo "    <TD WIDTH=\"1%\" VALIGN=\"TOP\">
				echo "      <DIV STYLE=\"float:left;\">\n";
				echo "        <A HREF=\"".PluginEngine::getLink($this,array("modus"=>"del_comment","photo_id"=>$p->get_photo_id(),"comment_id"=>$comment->get_comment_id()))."\" onClick=\"return confirm('Soll der Kommentar wirklich gel&ouml;scht werden?');\"><IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/trash.gif\" ALT=\"Kommentar l&ouml;schen\" TITLE=\"Kommentar l&ouml;schen\" BORDER=\"0\"></A>\n";
				echo "      </DIV>\n";
                	        //echo "  </TR>\n";
			}
			echo "</DIV>\n";
			echo "</CENTER>\n";
			//echo "</TABLE>\n";
		}

		echo "    </TD>\n";
                echo "    <TD CLASS=\"blank\" WIDTH=\"2%\" ALIGN=\"CENTER\" VALIGN=\"TOP\">".$this->createInfoBox("modules.jpg")."</TD>\n";
                echo "  </TR>\n";
                echo "</TABLE>\n";
	}


	function public_show_albums() {
		global $PHP_SELF;

		$this->get_scriptaculous();

		echo "<A NAME=\"anker\">\n";

		$c = new Controller();
		$u = $this->getRequestedUser();
		// $albums = $c->get_all_albums($GLOBALS['auth']->auth['uid']);
		$albums = $c->get_all_albums($u->getUserId());
		if (count($albums) > 0) {
			echo "<TABLE BORDER=\"0\" ALIGN=\"center\">\n";
			$count = 0;
			echo "  <TR>\n";
			foreach ($albums as $a) {

				if ($a->get_public() == 0)
                                        continue;


?><script type="text/javascript">
var id_current = 0;
var start_<?=$a->get_album_id()?> = false;

function show_<?=$a->get_album_id()?> ()
{
 start_<?=$a->get_album_id()?> = true;
 var t_img = new Array(); 
 <?
 				$photos = $c->get_all_photos_in_album($u->getUserId(), $a->get_album_id());
				if (count($photos) > 0) {
					$ind = 0;
					foreach ($photos as $p) {
						echo "t_img[$ind] = \"".$GLOBALS['ABSOLUTE_URI_STUDIP'].$this->getPluginpath()."/download.php?modus=thumb&photo_id=".$p->get_photo_id()."\";\n";
						$ind++;
					}
				}
 ?>

 var img = $('slideshow_<?=$a->get_album_id()?>');

   Element.hide('slideshow_<?=$a->get_album_id()?>');
   img.src = '';
   if (id_current < (t_img.length-1)) id_current++;
   else id_current = 0;
   img.src = t_img[id_current];
   new Effect.Appear('slideshow_<?=$a->get_album_id()?>');

 window.setTimeout("show_<?=$a->get_album_id()?>()",5000);
}
</script>
<?

				if ($count == 4) {
					$count = 0;
					echo "  </TR>\n";
					echo "  <TR>\n";
				}
				echo "  <TD WIDTH=\"160px\" ALIGN=\"center\">\n";
				echo "    <DIV STYLE=\"width:160px; height:160px; margin:1px; padding:1px; border-color:gray; border-width:1px; border-style:solid\">\n";
				//echo "      <A HREF=\"".PluginEngine::getLink($this,array("modus"=>"view_album","album_id"=>$a->get_album_id()),$this->view)."\">\n";
				echo "      <DIV STYLE=\"clear:both; position:relative; height:130px; text-align:center;\">\n";
				echo "        <A HREF=\"$PHP_SELF?modus=view_album&album_id=".$a->get_album_id()."&username=".$u->getUserName()."#anker\">\n";
				if ($a->get_start_photo_id() != "")
					// echo "      <IMG SRC=\"".$GLOBALS['ABSOLUTE_URI_STUDIP']."plugins/packages/ZMML/MyPhotoPlugin/download.php?modus=thumb&photo_id=".$a->get_start_photo_id()."\" BORDER=\"0\">\n";
					echo "        <IMG onMouseOver=\"if (!start_".$a->get_album_id().") show_".$a->get_album_id()."()\" ID=\"slideshow_".$a->get_album_id()."\" SRC=\"".$GLOBALS['ABSOLUTE_URI_STUDIP'].$this->getPluginpath()."/download.php?modus=thumb&photo_id=".$a->get_start_photo_id()."\" BORDER=\"0\" STYLE=\"position:absolute; top:1px; left:20px; clip:rect(0px, 120px, 120px, 0px);\">\n";
				else
					echo "        <IMG SRC=\"".$GLOBALS['ABSOLUTE_URI_STUDIP']."user/nobody.jpg\" BORDER=\"0\" HEIGHT=\"160\" STYLE=\"position:absolute; top:1px; left:20px; clip:rect(0px, 120px, 120px, 0px);\">\n";
				echo "        </A>\n";
				echo "      </DIV>\n";
				echo "      <DIV STYLE=\"clear:both; position:relative; text-align:center;\">\n";
				echo "        <A HREF=\"$PHP_SELF?modus=view_album&album_id=".$a->get_album_id()."&username=".$u->getUserName()."#anker\"><FONT SIZE=\"-1\">".(htmlReady(strlen($a->get_titel())>30 ? substr($a->get_titel(),0,30)."..." : $a->get_titel()))."</FONT></A>\n";
				echo "      </DIV>\n";
				echo "    </DIV>\n";
				echo "  </TD>\n";
				$count++;
			}
			echo "  </TR>\n";
			echo "</TABLE>\n";
		}
	}

	function admin_show_albums() {
		$c = new Controller();
		$u = $this->getRequestedUser();
		// $albums = $c->get_all_albums($GLOBALS['auth']->auth['uid']);
		$albums = $c->get_all_albums($u->getUserId());
/*?><script type="text/javascript">
   top.messagewindow.close();
</script><?*/
		echo "<TABLE BORDER=\"0\" WIDTH=\"100%\">\n";
       	        echo "  <TR>\n";
                echo "    <TD VALIGN=\"TOP\" CLASS=\"blank\">\n";
		if (count($albums) > 0) {

			echo "<TABLE BORDER=\"0\" ALIGN=\"center\">\n";
			$count = 0;
			echo "  <TR>\n";
			foreach ($albums as $a) {

				if ($count == 4) {
					$count = 0;
					echo "  </TR>\n";
					echo "  <TR>\n";
				}
				echo "  <TD WIDTH=\"160px\" ALIGN=\"center\">\n";
				echo "    <DIV STYLE=\"width:160px; height:160px; margin:1px; padding:1px; border-color:gray; border-width:1px; border-style:solid\">\n";
				echo "      <DIV STYLE=\"clear:both; position:relative; height:130px; text-align:center; z-index:0;\">\n";
				echo "        <A HREF=\"".PluginEngine::getLink($this,array("modus"=>"view_album","album_id"=>$a->get_album_id()))."\">\n";
				if ($a->get_start_photo_id() != "")
					// echo "      <IMG SRC=\"".$GLOBALS['ABSOLUTE_URI_STUDIP']."plugins/packages/ZMML/MyPhotoPlugin/download.php?modus=thumb&photo_id=".$a->get_start_photo_id()."\" BORDER=\"0\">\n";
					echo "        <IMG SRC=\"".$GLOBALS['ABSOLUTE_URI_STUDIP'].$this->getPluginpath()."/download.php?modus=thumb&photo_id=".$a->get_start_photo_id()."\" BORDER=\"0\" STYLE=\"position:absolute; top:1px; left:20px; clip:rect(0px, 120px, 120px, 0px);\">\n";
				else
					echo "        <IMG SRC=\"".$GLOBALS['ABSOLUTE_URI_STUDIP']."user/nobody.jpg\" BORDER=\"0\" HEIGHT=\"160\" STYLE=\"position:absolute; top:1px; left:20px; clip:rect(0px, 120px, 120px, 0px);\">\n";
				echo "        </A>\n";
				if ($a->get_public() == 1)
					echo "        <IMG ALT=\"F&uuml;r andere sichtbar\" TITLE=\"F&uuml;r andere sichtbar\" STYLE=\"clear:both; position:absolute; top:1px; left:1px; z-index:9999;\" SRC=\"".$GLOBALS['ASSETS_URL']."/images/vote-icon-visible.gif\">\n";
				echo "      </DIV>\n";
				echo "      <DIV STYLE=\"clear:both; position:relative; text-align:center;\">\n";
				echo "        <A HREF=\"".PluginEngine::getLink($this,array("modus"=>"view_album","album_id"=>$a->get_album_id()))."\"><FONT SIZE=\"-1\">".(htmlReady(strlen($a->get_titel())>30 ? substr($a->get_titel(),0,30)."..." : $a->get_titel()))."</FONT></A>\n";
				echo "      </DIV>\n";
				echo "    </DIV>\n";
				echo "  </TD>\n";
				$count++;
			}
			echo "  </TR>\n";
			echo "</TABLE>\n";
		}
		echo "    </TD>\n";
                echo "    <TD CLASS=\"blank\" WIDTH=\"2%\" ALIGN=\"CENTER\" VALIGN=\"TOP\">".$this->createInfoBox("modules.jpg")."</TD>\n";
                echo "  </TR>\n";
                echo "</TABLE>\n";
	}

	function showAdministrationPage() {
		$this->show();
	}

	function show() {
		$modus = $_REQUEST['modus'];
		$c = new Controller();
		$u = $this->getRequestedUser();
		// Sind wir berechtigt?
		if ($u->getUserId() == $GLOBALS['auth']->auth['uid'] || $GLOBALS['perm']->have_perm("root")) {
			$this->view = "show";
			if ($_REQUEST['plugin_subnavi_params'] == "new_album") {
				$this->new_album();
			}
			$messaging=new messaging;
			
			// modus....
			if ($modus == "del_photo") {
				$p = new Photo();
				$p->load($_REQUEST['photo_id']);
				$p_user_id = $p->get_user_id();
				$a = new Album();
				$a->load($p->get_album_id());
				if ($p->get_user_id() == $GLOBALS['auth']->auth['uid'] || $GLOBALS['perm']->have_perm("root")) {
					$p->delete();
					if ($_REQUEST['photo_id'] == $a->get_start_photo_id()) {
						$a->set_start_photo_id("");
						$a->save();
					}
					if ($p_user_id != $GLOBALS['auth']->auth['uid'] && $GLOBALS['perm']->have_perm("root")) {
						$msg = sprintf("Ein Foto in Deinem Album \"%s\" wurde von der Administration gelscht.",$a->get_titel());
						$messaging->insert_message($msg, get_username($p_user_id), "____%system%____", FALSE, FALSE, 1, FALSE, _("Foto gelscht"));
					}
				}
				$modus = "view_album";
			}
			if ($modus == "del_album") {
				$a = new Album();
				$a->load($_REQUEST['album_id']);
				$a_user_id = $a->get_user_id();
				$titel = $a->get_titel();
				if ($a->get_user_id() == $GLOBALS['auth']->auth['uid'] || $GLOBALS['perm']->have_perm("root")) {
					$a->delete();
					if ($a_user_id != $GLOBALS['auth']->auth['uid'] && $GLOBALS['perm']->have_perm("root")) {
						$msg = sprintf("Dein Album \"%s\" wurde von der Administration gelscht.",$titel);
						$messaging->insert_message($msg, get_username($a_user_id), "____%system%____", FALSE, FALSE, 1, FALSE, _("Album gelscht"));
					}
				}
				$modus = FALSE;
			}
			if ($modus == "del_comment") {
				$comment = new Comment();
				$comment->load($_REQUEST['comment_id']);
				$p = new Photo();
				$p->load($_REQUEST['photo_id']);
				if ($p->get_user_id() == $GLOBALS['auth']->auth['uid'] || $GLOBALS['perm']->have_perm("root")) {
					$comment->delete();
					if ($p->get_user_id() != $GLOBALS['auth']->auth['uid'] && $GLOBALS['perm']->have_perm("root")) {
						$a = new Album();
						$a->load($p->get_album_id());
						$msg = sprintf("Ein Kommentar in Deinem Album \"%s\" wurde von der Administration gelscht.",$a->get_titel());
						$messaging->insert_message($msg, get_username($p->get_user_id()), "____%system%____", FALSE, FALSE, 1, FALSE, _("Kommentar gelscht"));
					}
				}
				$modus = "show_photo_maxsize";
			}
			if ($modus == "add_album") {
				if (strlen(trim($_REQUEST['titel'])) > 0) {
					$a = new Album();
					$a->set_titel(trim($_REQUEST['titel']));
					$a->set_untertitel(trim($_REQUEST['untertitel']));
					$a->set_beschreibung(trim($_REQUEST['beschreibung']));
					$a->set_user_id($GLOBALS['auth']->auth['uid']);
					$a->set_mkdate(time());
					$a->save();
				}
				$modus = FALSE;
			}
			if ($modus == "save_album") {
				if (strlen(trim($_REQUEST['titel'])) > 0) {
					$sortierung = explode("photos[]=", preg_replace(array("/\&/"),array(""),$_REQUEST['sortierung']));
					$a = new Album();
					$a->load($_REQUEST['album_id']);
					$a->set_titel(trim($_REQUEST['titel']));
					$a->set_untertitel(trim($_REQUEST['untertitel']));
					$a->set_beschreibung(trim($_REQUEST['beschreibung']));
					$a->set_public($_REQUEST['public']);
					$a->set_allow_comments($_REQUEST['allow_comments']);
					$a->set_start_photo_id($_REQUEST['photo_id']);
					$a->save();
					$count = 0;
					foreach ($sortierung as $sort) {
						if (trim($sort) != "") {
							Photo::update_sort($sort, $count);
							$count++;
						}
					}

				}
				$modus = "view_album";
			}
			if ($modus == "save_photo") {
				$p = new Photo();
				$p->load($_REQUEST['photo_id']);
				$p->set_titel($_REQUEST['titel']);
				$p->set_beschreibung($_REQUEST['beschreibung']);
				$p->save();
				$modus = "show_photo_maxsize";
			}
			/*if ($modus == "set_start_photo") {
				$a = new Album();
				$a->load($_REQUEST['album_id']);
				$a->set_start_photo_id($_REQUEST['photo_id']);
				$a->save();
				$modus = "view_album";
			}*/
			if ($modus == "view_album") {
				$this->admin_view_album($_REQUEST['album_id']);
			}
			if ($modus == "make_comment") {
				$co = new Comment();
				$co->set_photo_id($_REQUEST['photo_id']);
				$co->set_user_id($GLOBALS['auth']->auth['uid']);
				$co->set_mkdate(time());
				$co->set_comment($_REQUEST['comment']);
				$co->save();
				$modus = "show_photo_maxsize";
			}
			if ($modus == "show_photo_maxsize") {
				$this->admin_show_foto_maxsize($_REQUEST['photo_id']);
			}
			if ($modus == "add_photos") {
				$c->new_file_upload(PluginEngine::getLink($this,array()), $_REQUEST['album_id']);
			}
			if ($modus == "foto_upload") {
				global $imgfile, $imgfile_name, $imgfile_size;
				if ($imgfile && $_REQUEST['album_id']) {
					$msg = $c->add_new_foto($imgfile, $imgfile_size, $imgfile_name, $_REQUEST['album_id'], $_REQUEST['titel'], $_REQUEST['beschreibung']);
					if ($msg)
						parse_msg($msg);
				}
				$modus = FALSE;
			}
			// ZIP-Upload
			if ($modus == "zip_upload") {
				global $zipfile, $zipfile_name, $zipfile_size;
				if ($zipfile && $_REQUEST['album_id']) {
					$msg = $c->add_new_zip($zipfile, $zipfile_size, $zipfile_name, $_REQUEST['album_id']);
					if ($msg)
						parse_msg($msg);
				}
				$modus = FALSE;
			}

			if (!$_REQUEST['plugin_subnavi_params'] && !$modus)
				$this->admin_show_albums();
		}
	}

}

?>
