<?php
/**
* Photo.class.php
*
*
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
* @version              $Id: Photo.class.php,v 1.1.1.1 2007-02-16 11:54:34 jankul Exp $
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// FotoContest.class.php
// Copyright (C) 2007 Jan Kulmann <jankul@tzi.de>
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+


require_once $GLOBALS['ABSOLUTE_PATH_STUDIP'].("/functions.php");

class Photo {

	var $photo_id;
	var $user_id;
	var $album_id;
	var $mkdate;
	var $titel;
	var $beschreibung;
	var $file_id;
	var $ext;
	var $sort;

	function reset() {
		$this->photo_id = "";
		$this->user_id = "";
		$this->album_id = "";
		$this->mkdate = 0;
		$this->titel = "";
		$this->beschreibung = "";
		$this->file_id = "";
		$this->ext = "";
		$this->sort = 0;
	}

	function Photo() {
		$this->reset();
	}

	function load($photo_id) {
		$db = new DB_Seminar();
		$db->queryf("SELECT * FROM mp_photo WHERE photo_id='%s'",$photo_id);
		if ($db->next_record()) {
			$this->photo_id = $db->f("photo_id");
	                $this->user_id = $db->f("user_id");
        	        $this->album_id = $db->f("album_id");
                	$this->mkdate = $db->f("mkdate");
	                $this->titel = $db->f("titel");
        	        $this->beschreibung = $db->f("beschreibung");
			$this->file_id = $db->f("file_id");
			$this->ext = $db->f("ext");
			$this->sort = $db->f("sort");
		}
	}

	function save() {
		$db = new DB_Seminar();
		if ($this->photo_id == "") {
			$this->photo_id = $this->get_new_id();
			$db->queryf("INSERT INTO mp_photo (photo_id, user_id, album_id, mkdate, titel, beschreibung, file_id, ext, sort) VALUES ('%s','%s','%s',%d,'%s','%s','%s','%s',%d)",
					$this->photo_id,
					$this->user_id,
					$this->album_id,
					$this->mkdate,
					$this->titel,
					$this->beschreibung,
					$this->file_id,
					$this->ext,
					$this->sort);
		} else {
			$db->queryf("UPDATE mp_photo SET titel='%s', beschreibung='%s', sort=%d WHERE photo_id='%s' AND user_id='%s'",
					$this->titel,
					$this->beschreibung,
					$this->sort,
					$this->photo_id,
					$this->user_id);
		}
	}

	function delete() {
		if ($this->photo_id != "") {
			$db = new DB_Seminar();
			$db->queryf("DELETE FROM mp_photo WHERE photo_id='%s' AND user_id='%s'",$this->photo_id,$this->user_id);
			$db->queryf("DELETE FROM mp_photo_comment WHERE photo_id='%s'",$this->photo_id);
			$db->queryf("DELETE FROM mp_file_content WHERE file_id='%s'",$this->file_id);
			$this->reset();
		}
	}

	function update_sort($photo_id, $sort) {
		if ($photo_id != "") {
			$db = new DB_Seminar();
			$db->queryf("UPDATE mp_photo SET sort=%d WHERE photo_id='%s'", $sort, $photo_id);
		}
	}

	function get_photo_id() {
		return $this->photo_id;
	}

	function get_user_id() {
		return $this->user_id;
	}

	function get_album_id() {
		return $this->album_id;
	}

	function get_mkdate() {
		return $this->mkdate;
	}

	function get_titel() {
		return $this->titel;
	}

	function get_beschreibung() {
		return $this->beschreibung;
	}

	function get_file_id() {
		return $this->file_id;
	}

	function get_ext() {
		return $this->ext;
	}

	function get_sort() {
		return $this->sort;
	}

	function get_file_content() {
		if ($this->file_id != "") {
			$db = new DB_Seminar();
			$db->queryf("SELECT file_content FROM mp_file_content WHERE file_id='%s'",$this->file_id);
			if ($db->next_record())
				return $db->f("file_content");
		}
		return null;
	}

	function get_file_content_thumb() {
		if ($this->file_id != "") {
			$db = new DB_Seminar();
			$db->queryf("SELECT file_content_thumb FROM mp_file_content WHERE file_id='%s'",$this->file_id);
			if ($db->next_record())
				return $db->f("file_content_thumb");
		}
		return null;
	}

	function set_file_id($f) {
		$this->file_id = $f;
	}

	function set_photo_id($id) {
		$this->photo_id = $id;
	}

	function set_user_id($id) {
		$this->user_id = $id;
	}

	function set_album_id($id) {
		$this->album_id = $id;
	}

	function set_titel($t) {
		$this->titel = $t;
	}

	function set_beschreibung($b) {
		$this->beschreibung = $b;
	}

	function set_mkdate($d) {
		$this->mkdate = $d;
	}

	function set_ext($e) {
		$this->ext = $e;
	}

	function set_sort($s) {
		$this->sort = $s;
	}

	function set_file_content($c,$thumb) {
		if ($c != "" && $thumb != "" && $this->file_id != "") {
			$db = new DB_Seminar();
			$db->queryf("INSERT INTO mp_file_content (file_id, file_content, file_content_thumb) VALUES ('%s','%s','%s')",$this->file_id, $c, $thumb);
		}
	}

	// Generiert eine eindeutige ID.
        // return: string (id)
        function get_new_id() {
                return md5(uniqid(time()));
        }
}

?>
